/* Markus Opitz 2022
 * @ instructables.com
 */

// flex sensor
int flag = 0;  
int trigger = 900;

// LED ring
#include <Adafruit_NeoPixel.h>
#define PIN 2   // D2
#define NUMPIXELS 12    // How many NeoPixels are attached to the Arduino?
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);
int x,y,z;
 
//DF Player
#include "Arduino.h"
#include "SoftwareSerial.h"
#include "DFRobotDFPlayerMini.h"
SoftwareSerial mySoftwareSerial(11,10); // RX, TX
DFRobotDFPlayerMini myDFPlayer;


void setup() {


  mySoftwareSerial.begin(9600); //DF Player
  delay(10);

 // DF Player init
  Serial.println();
  Serial.println(F("Initializing DFPlayer ... (May take 3~5 seconds)"));
  if (!myDFPlayer.begin(mySoftwareSerial)) {  //Use softwareSerial to communicate with mp3.
    Serial.println(F("Unable to begin:"));
    Serial.println(F("1.Please recheck the connection!"));
    Serial.println(F("2.Please insert the SD card!"));
    while(true){
      delay(0); // Code to compatible with ESP8266 watch dog.
    }
  }
  Serial.println(F("DFPlayer Mini online."));
  myDFPlayer.volume(20);  //Set volume value. From 0 to 30
  Serial.println(F("playing mp3 now"));


  Serial.begin(9600);
  pinMode(A0,INPUT);  //flex sensor
  pixels.begin();     //LED
  
}



void loop()  {

  int flex = analogRead(A0); // Reading sensor values
  //Serial.print("Flex1 value = ");
  Serial.println(flex); // Printing Sensor value on Serial monitor


  if ((flex < trigger) && (flag == 0))  {
     myDFPlayer.play(1);
     lightfadeon();
     flag = 1;
  }
  if ((flex < trigger) && (flag == 1)) {
    lighton();
  }
  if ((flex > trigger+50) && (flag == 1)) {
    myDFPlayer.play(2);
    lightfadeoff();
    flag = 0;
  }
  if ((flex > trigger+50) && (flag == 0))  {
     lightoff();
     flag = 0;
  }
  delay(5);

}



void lightfadeon() {        //repulsor fade on
  
  //Serial.println(" + + + + + ON + + + + + +");
  for(z=0; z<256; z=z+5)
  {
    for(int p=0; p<12; p++) {
      x = z; y = z;
      if (x>225) x = 225; if (y>225) y = 225;
      pixels.setPixelColor(p, pixels.Color(x,y,z));
      pixels.show();
    }    
    //Serial.print(x);Serial.print(", ");Serial.print(y);Serial.print(", ");Serial.println(z);
  }
}

void lightfadeoff() {      //repulsor fade off
  
  //Serial.println(" - - - - OFF - - - - -  ");
  for(z=255; z>=0; z=z-5)
  {
    for(int p=0; p<12; p++) {
      x = z; y = z;
      pixels.setPixelColor(p, pixels.Color(x,y,z));
      pixels.show();
    }
    //Serial.print(x);Serial.print(", ");Serial.print(y);Serial.print(", ");Serial.println(z);
  }
}

void lighton() {      //repulsor on
    for(int p=0; p<12; p++) {
      pixels.setPixelColor(p, pixels.Color(235,235,255));
      pixels.show();
    }    
}

void lightoff() {      //repulsor off
    for(int p=0; p<12; p++) {
      pixels.setPixelColor(p, pixels.Color(0,0,0));
      pixels.show();
    }    
}
